DECLARE @totalMem BIGINT

SELECT @totalMem = cntr_value
FROM sys.dm_os_performance_counters
WHERE [counter_name] = 'Target Server Memory (KB)'

SELECT    [object_name]
		, counter_name
		, cntr_value
		, cntr_type
		, CASE  WHEN counter_name = 'SQL Cache Memory (KB)'		THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Stolen Server Memory (KB)' THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Connection Memory (KB)'	THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Free Memory (KB)'			THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Optimizer Memory (KB)'		THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Lock Memory (KB)'			THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Total Server Memory (KB)'	THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Target Server Memory (KB)'	THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Database pages'			THEN CONVERT(DECIMAL(32,2),cntr_value) / @totalMem
				WHEN counter_name = 'Memory Grants Outstanding'	THEN CONVERT(DECIMAL(32,2),cntr_value)
				WHEN counter_name = 'Memory Grants Pending'		THEN CONVERT(DECIMAL(32,2),cntr_value)   
		  ELSE
				0
		  END AS 'PercentOfTotalMemoryUsed'
		, CASE  WHEN counter_name = 'SQL Cache Memory (KB)'		THEN CONVERT(DECIMAL(32,2),cntr_value) 
				WHEN counter_name = 'Stolen Server Memory (KB)' THEN CONVERT(DECIMAL(32,2),cntr_value) 
				WHEN counter_name = 'Connection Memory (KB)'	THEN CONVERT(DECIMAL(32,2),cntr_value) 
				WHEN counter_name = 'Free Memory (KB)'			THEN CONVERT(DECIMAL(32,2),cntr_value) 
				WHEN counter_name = 'Optimizer Memory (KB)'		THEN CONVERT(DECIMAL(32,2),cntr_value) 
				WHEN counter_name = 'Lock Memory (KB)'			THEN CONVERT(DECIMAL(32,2),cntr_value) 
				WHEN counter_name = 'Total Server Memory (KB)'	THEN 0 
				WHEN counter_name = 'Target Server Memory (KB)'	THEN 0 
				WHEN counter_name = 'Database pages'			THEN CONVERT(DECIMAL(32,2),cntr_value) 
				WHEN counter_name = 'Memory Grants Outstanding'	THEN 0
				WHEN counter_name = 'Memory Grants Pending'		THEN 0  
		  ELSE
				0
		  END AS 'SpaceConsumedInMemory'
FROM sys.dm_os_performance_counters
WHERE [counter_name] IN (	  'Stolen Server Memory (KB)'
							, 'Total Server Memory (KB)'
							, 'Target Server Memory (KB)'
							, 'SQL Cache Memory (KB)'
							, 'Optimizer Memory (KB)'
							, 'Memory Grants Outstanding'
							, 'Memory Grants Pending'
							, 'Free Memory (KB)'
							, 'Connection Memory (KB)'
							, 'Lock Memory (KB)')
							AND instance_name IN ('','_total')