--From https://www.sqlshack.com/insight-into-the-sql-server-buffer-cache/
--Number of database pages by database

SELECT
    databases.name AS 'DatabaseName',
	Count(*) 'NumberOfPages',
    COUNT(*) * 8 / 1024 AS 'MBUsed',
	'www.sqlshack.com/insight-into-the-sql-server-buffer-cache/' AS 'Source'
FROM sys.dm_os_buffer_descriptors
INNER JOIN sys.databases
ON databases.database_id = dm_os_buffer_descriptors.database_id
GROUP BY databases.name
ORDER BY MBUsed DESC;  